=== debian/changelog ===
digikam (4:8.4.0-3ubuntu2) oracular; urgency=medium

  * Update path for webengineprocess for qt6 in apparmor profile. (LP: #2046844)

 -- Scarlett Moore <sgmoore@debian.org>  Tue, 17 Sep 2024 12:34:55 -0700

digikam (4:8.4.0-3ubuntu1) oracular; urgency=medium

  * Merge with Debian: Remaining changes:
    - Add apparmor profile to fix userns:
      + Add debian/digikam-apparmor.
      + debian/control: Depend on apparmor, build depend on dh-apparmor and
        debhelper-compat (=13).
      + debian/rules:copy profile to tmp dir and invoke dh_apparmor.
      + debian/digikam.install: Install profile.
  * Merged to fix FTBFS against latest ffmpeg.

 -- Rik Mills <rikmills@kde.org>  Mon, 19 Aug 2024 10:00:07 +0100

digikam (4:8.4.0-3) unstable; urgency=medium

  [ Steve Robbins ]
  * [fd795f2] Qt webengine is now mandatory, so reduce the build architectures
    to those supported by webengine: amd64 arm64 armhf i386

 -- Steve M. Robbins <smr@debian.org>  Sat, 17 Aug 2024 10:53:04 -0500

digikam (4:8.4.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [5181521] Package qt6-webengine-dev is only available for architectures amd64 arm64 armhf i386.

 -- Steve M. Robbins <smr@debian.org>  Thu, 15 Aug 2024 22:11:39 -0500

digikam (4:8.4.0-1) experimental; urgency=medium

  [ Steve Robbins ]
  * [408bb7d] New upstream version 8.4.0
  * [17a3619] Rebase patches
  * [a71254f] Updates to build with Qt6 & KDE Frameworks 6.  
    Remove obsolete configuration option ENABLE_QWEBENGINE.

 -- Steve M. Robbins <smr@debian.org>  Sun, 14 Jul 2024 17:36:36 -0500

digikam (4:8.3.0-2ubuntu4) oracular; urgency=medium

  * Rebuild against new libavcodec61.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 17:34:35 +0200

digikam (4:8.3.0-2ubuntu3) oracular; urgency=medium

  * Properly address the apparmor profile issue by adding multiple
    lines for the different architectures we want to support until 
    @multiarch is supported. This closes (LP: #2064492)

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 11 Jul 2024 04:22:02 -0700
